//Umsetzung der Lenkregelung als Zustandsregler.
//3. Zustand: Integral des Lenkwinkels.
//Zunchst: Sollwert=0, so keine Notwendigkeit ein "*-System" zu substituieren.
m = 1.0;
D = 5.0;
r = 0.1;

//Flacher Quader der Kantenlnge 2r:
J = m*(2*r*2*r)/6;

Drot = 2.0*r*r*D;

K = 0.7;
I =  0.1;

//Zustnde: phi, omega, integphi
 A = [
            [0,      1,  0];
            [0, -Drot/J,  0];
            [1,      0,  0]
        ];


    B = [
            [0];
            [1/J];
            [0]
        ]

R=ppol(A,B,[-40,-1+%i,-1-%i])

function f = rechteSeite(t,y)
    f = (A-B*R)*y;  //und dann simuliee ich das einfach!!!
endfunction

t = linspace(0,30,3000);
y0 = [1,0,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);

//plot(t,y(1,:)');

//spec(A-B*R)

//Riccati

//Ausgangsmatrix:
CC = [[1,0,0];[0,1,0];[0,0,1]]; 

//Durchgangsmatrix:
//DD = [[1,0];[0,1]];
DD = [0;0;0];

AA=A;
BB=B;

GG = syslin('c',AA,BB,CC,DD);
[XX,FF] = gcare(GG);

RR = BB'*XX

function f = rechteSeiteRiccati(t,y)
    f = (A-B*RR)*y;  //und dann simuliee ich das einfach!!!
endfunction

yricc  = ode(y0,t0,t,rechteSeite);

plot(t,y(1,:)',t,yricc(1,:));






